#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "err.h"

int err_set = 0;
char err_msg[ERR_SIZE];
int err_no;

int err_report (int errno, char *format, ...) {
	va_list ap;

	if (!err_set) 
		err_set = 1;

	err_no = errno;
	va_start (ap, format);
	vsprintf (err_msg, format, ap);
	va_end (ap);

	return 1;
}

char *err_get () {
	if (!err_set)
		strcpy (err_msg, "no error");
	return err_msg;
}	

int err_getno () {
	if (err_set)
		return err_no;
	else
		return E_NONE;
}

char *err_getstr (int err_no) {
	int i = 0;

	while (i <= E_UNKNOWN) {
		if (errors[i].err_no == err_no)
			return errors[i].err_str;

		 i++;
	}

	return "unknown error";
}

void err_discard() {
	err_set = 0;
}

